package org.processmining.hybridminer.dialogs;

import java.awt.Component;
import java.awt.GridLayout;
import java.util.Hashtable;

import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.hybridminer.plugins.HybridCGMinerSettings;


public class CGDialog extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3587595452197538653L;
	@SuppressWarnings("unused")
	//private FuzzyCGConfiguration configuration;
	private HybridCGMinerSettings settings;

	public CGDialog(UIPluginContext context, XLog log, 
			final HybridCGMinerSettings settings) {
		super(new GridLayout(4,2,10,1));
		this.settings = settings;
		
		//final JPanel label1 = new JPanel(new GridLayout(3,1,1,-10));
		//EmptyBorder panelBorder = new EmptyBorder(10, 5, 10, 10);
	    //label1.setBorder(panelBorder);
	    
		final JLabel positiveObservationsLabel = new JLabel();
		positiveObservationsLabel.setText("<html>Minimal activity frequency <br>(an activity should occur at least in x cases: set to 0 to include all activities)</html>");
		this.add(positiveObservationsLabel);

/*		final JLabel positiveObservationsLabel2 = new JLabel();
		positiveObservationsLabel2.setText("(an activity should occur at least in x cases: ");
		label1.add(positiveObservationsLabel2);
		
		final JLabel positiveObservationsLabel3 = new JLabel();
		positiveObservationsLabel3.setText("set to 0 to include all activities)");
		label1.add(positiveObservationsLabel3);		

		//label1.setBackground(new Color(150f,150f,150f));
		//label1.setBackground(Color.lightGray);
		this.add(label1);
*/		
		final JSlider positiveObservationsSlider = new JSlider();
	    int maxOccurrence = settings.getMaxOccurrence();	
		positiveObservationsSlider.setMinimum(0);
		positiveObservationsSlider.setMaximum(maxOccurrence);
		
		int intValue = settings.getPositiveObservationThreshold();
		positiveObservationsSlider.setValue(intValue);
		positiveObservationsSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				settings.setPositiveObservationThreshold(positiveObservationsSlider.getValue());
			}
		});
		int middle = maxOccurrence/2;
		positiveObservationsSlider.setMajorTickSpacing(middle);
		positiveObservationsSlider.setMinorTickSpacing(maxOccurrence/10);
		positiveObservationsSlider.setPaintTicks(true);
		Hashtable<Integer, JLabel> labelTable = new Hashtable<Integer, JLabel>();
		labelTable.put(0, new JLabel("0"));
		labelTable.put(middle, new JLabel(String.valueOf(middle)));
		labelTable.put(maxOccurrence, new JLabel(String.valueOf(maxOccurrence)));
		positiveObservationsSlider.setLabelTable(labelTable);
		positiveObservationsSlider.setPaintLabels(true);
		this.add(positiveObservationsSlider);
		
		Component space = Box.createVerticalStrut(20);
		this.add(space);

		space = Box.createHorizontalStrut(10);
		this.add(space);
		
		//final JPanel label2 = new JPanel(new GridLayout(3,1,1,-10));

		final JLabel sureThresholdLabel = new JLabel();
		sureThresholdLabel.setText("<html>Strong causality threshold <br>(lower bound for a strong causality relation between two activities)</html>");
		this.add(sureThresholdLabel);
		
/*		final JLabel sureThresholdLabel2 = new JLabel();
		sureThresholdLabel2.setText("(lower bound for a strong causality relation ");
		label2.add(sureThresholdLabel2);

		final JLabel sureThresholdLabel3 = new JLabel();
		sureThresholdLabel3.setText(" between two activities)");
		label2.add(sureThresholdLabel3);

		this.add(label2);*/

		
		//space = Box.createHorizontalStrut(10);
		//this.add(space);
		
		final JSlider sureThresholdSlider = new JSlider();
		sureThresholdSlider.setMinimum(0);
		sureThresholdSlider.setMaximum(100);
		
		intValue = (int) (settings.getSureThreshold()*100);
		sureThresholdSlider.setValue(intValue);
		sureThresholdSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				settings.setSureThreshold(sureThresholdSlider.getValue()/100.0);
			}
		});
		sureThresholdSlider.setMajorTickSpacing(50);
		sureThresholdSlider.setMinorTickSpacing(10);
		sureThresholdSlider.setPaintTicks(true);
		labelTable = new Hashtable<Integer, JLabel>();
		labelTable.put(0, new JLabel("0%"));
		labelTable.put(50, new JLabel("50%"));
		labelTable.put(100, new JLabel("100%"));
		sureThresholdSlider.setLabelTable(labelTable);
		sureThresholdSlider.setPaintLabels(true);
		this.add(sureThresholdSlider);
		
		
		space = Box.createVerticalStrut(20);
		this.add(space);
		
		space = Box.createHorizontalStrut(20);
		this.add(space);

		
		//final JPanel label3 = new JPanel(new GridLayout(3,1,1,-10));

		final JLabel questionMarkThresholdLabel = new JLabel();
		questionMarkThresholdLabel.setText("<html>Unsure arc threshold <br> (lower bound for a weak relation between two activities: <br>set to 100% avoid unsure arcs)</html>");
		this.add(questionMarkThresholdLabel);

/*		final JLabel questionMarkThresholdLabel2 = new JLabel();
		questionMarkThresholdLabel2.setText("(lower bound for a weak relation between two activities:");
		label3.add(questionMarkThresholdLabel2);

		final JLabel questionMarkThresholdLabel3 = new JLabel();
		questionMarkThresholdLabel3.setText("set to 100% avoid unsure arcs)");
		label3.add(questionMarkThresholdLabel3);
		
		this.add(label3);
*/
		//space = Box.createHorizontalStrut(10);
		//this.add(space);
		
		final JSlider questionMarkThresholdSlider = new JSlider();
		questionMarkThresholdSlider.setMinimum(0);
		questionMarkThresholdSlider.setMaximum(100);
		
		questionMarkThresholdSlider.setMajorTickSpacing(50);
		questionMarkThresholdSlider.setMinorTickSpacing(10);
		questionMarkThresholdSlider.setPaintTicks(true);
		labelTable = new Hashtable<Integer, JLabel>();
		labelTable.put(0, new JLabel("0%"));
		labelTable.put(50, new JLabel("50%"));
		labelTable.put(100, new JLabel("100%"));
		questionMarkThresholdSlider.setLabelTable(labelTable);
		questionMarkThresholdSlider.setPaintLabels(true);
		this.add(questionMarkThresholdSlider);
		
		
		intValue = (int) (settings.getQuestionMarkThreshold()*100);
		questionMarkThresholdSlider.setValue(intValue);
		questionMarkThresholdSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				settings.setQuestionMarkThreshold(questionMarkThresholdSlider.getValue()/100.0);
			}
		});
		this.add(questionMarkThresholdSlider);


		
		space = Box.createVerticalStrut(20);
		this.add(space);
		
		space = Box.createHorizontalStrut(10);
		this.add(space);

		//final JPanel label4 = new JPanel(new GridLayout(3,1,1,-10));

		final JLabel causalityWeightLabel = new JLabel();
		causalityWeightLabel.setText("<html> Causality weight threshold  <br>(the lower the value, the more emphasis on concurrency detection: <br>set to 100% to focus on directly follows relation only)</html>");
		this.add(causalityWeightLabel);

/*		final JLabel causalityWeightLabel2 = new JLabel();
		causalityWeightLabel2.setText("(the lower the value, the more emphasis on concurrency detection: ");
		label4.add(causalityWeightLabel2);

		final JLabel causalityWeightLabel3 = new JLabel();
		causalityWeightLabel3.setText("set to 100% to focus on directly follows relation only)");
		label4.add(causalityWeightLabel3);
		
		this.add(label4);*/

		
		//space = Box.createHorizontalStrut(10);
		//this.add(space);
		
		final JSlider causalityWeightSlider = new JSlider();
		causalityWeightSlider.setMinimum(0);
		causalityWeightSlider.setMaximum(100);
		
		
		causalityWeightSlider.setMajorTickSpacing(50);
		causalityWeightSlider.setMinorTickSpacing(10);
		causalityWeightSlider.setPaintTicks(true);
		labelTable = new Hashtable<Integer, JLabel>();
		labelTable.put(0, new JLabel("0%"));
		labelTable.put(50, new JLabel("50%"));
		labelTable.put(100, new JLabel("100%"));
		causalityWeightSlider.setLabelTable(labelTable);
		causalityWeightSlider.setPaintLabels(true);
		this.add(causalityWeightSlider);
		
		
		intValue = (int) (settings.getCausalityWeight()*100);
		causalityWeightSlider.setValue(intValue);
		causalityWeightSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				settings.setCausalityWeight(causalityWeightSlider.getValue()/100.0);
			}
		});
		this.add(causalityWeightSlider);


		
		space = Box.createVerticalStrut(20);
		this.add(space);


		/*final JLabel allConnected = new JLabel();
		allConnected.setText("All tasks connected");
		this.add(allConnected);

		space = Box.createHorizontalStrut(10);
		this.add(space);

		JCheckBox connCbx = new JCheckBox();
		connCbx.setBackground(Color.GRAY);
		connCbx.setSelected(settings.getHmSettings().isUseAllConnectedHeuristics());
		connCbx.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				HeuristicsMinerSettings hMS = settings.getHmSettings();
				//hMS.setUseAllConnectedHeuristics(connCbx.isSelected());
				settings.setHmSettings(hMS);
			}
		});
		this.add(connCbx);*/
	}
}
