package org.processmining.hybridminer.models.causalgraph;

import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.AttributeMap.ArrowType;
import org.processmining.models.graphbased.directed.AbstractDirectedGraphEdge;

/**
 * Created by demas on 27/07/16.
 */
public abstract class HybridDirectedGraphEdge extends AbstractDirectedGraphEdge<HybridDirectedGraphNode, HybridDirectedGraphNode> {

	// Update by sabi (along with the respective setters and getters that are below)
	private double directSuccession;
	private double roundedODSD, roundedIDSD;
	private double directSuccessionDependency;
	private double abDependencyMetric;
	private double causalityMetric;
		
    public HybridDirectedGraphEdge(HybridDirectedGraphNode source, HybridDirectedGraphNode target) {
        super(source, target);
		getAttributeMap().put(AttributeMap.EDGEEND, ArrowType.ARROWTYPE_TECHNICAL);
		getAttributeMap().put(AttributeMap.EDGEENDFILLED, true);
    }
    
    /**
     * SETTERS
     */
     public void setDirectSuccession(double directSuccession)
     {
      	this.directSuccession=directSuccession;
     }
        
     public void setRounded(double roundedODSD,double roundedIDSD)
     {
    	 this.roundedODSD=roundedODSD;
         this.roundedIDSD=roundedIDSD;
     }
        
     public void setDirectSuccessionDependency(double directSuccessionDependency)
     {
    	 this.directSuccessionDependency=directSuccessionDependency;
     }
        
     public void setAbDependencyMetric(double abDependencyMetric)
     {
    	 this.abDependencyMetric=abDependencyMetric;
     }
        
     public void setCausalityMetric(double causalityMetric)
     {
    	 this.causalityMetric=causalityMetric;
     }
        
     /**
      * GETTERS
      */
      public double getDirectSuccession()
      {
    	  return this.directSuccession;
      }
        
      public double getRoundedODSD()
      {
    	  return this.roundedODSD;
      }
        
      public double getRoundedIDSD()
      {
    	  return this.roundedIDSD;
      }
       
      public double getDirectSuccessionDependency()
      {
    	  return this.directSuccessionDependency;
      }
        
      public double getAbDependencyMetric()
      {
    	  return this.abDependencyMetric;
      }

      public double getCausalityMetric()
      {
    	  return this.causalityMetric;
      }
}