package org.processmining.hybridminer.models.causalgraph;

import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.directed.AbstractDirectedGraphNode;

/**
 * Created by demas on 27/07/16.
 */
public class HybridDirectedGraphNode extends AbstractDirectedGraphNode {

    private final HybridCausalGraph graph;

    public HybridDirectedGraphNode(HybridCausalGraph graph) {
    	super();
        this.graph = graph;
    }

    public HybridDirectedGraphNode(HybridCausalGraph graph, String label) {
        this.graph = graph;
		getAttributeMap().put(AttributeMap.LABEL, label);
    }
    
  
    @Override
    public HybridCausalGraph getGraph() {
        return this.graph;
    }

	public String getLabel() {
		return super.getLabel();
	}

	//The equals method is inherited from AbstractGraphNode, and it is based on the id of the node!
    
}
