package org.processmining.hybridminer.models.hybridpetrinet.candidateplaceiterator;

import org.processmining.hybridminer.models.hybridpetrinet.PartialPlaceEvaluation;
import org.processmining.hybridminer.models.hybridpetrinet.candidateplacestrategy.EdgesOrderingCompatibleSelStrategy;
import org.processmining.models.graphbased.directed.AbstractDirectedGraphEdge;
import org.processmining.models.graphbased.directed.AbstractDirectedGraphNode;

import java.util.Iterator;
import java.util.Set;

public class EdgesOrderingIteratorOpt<N extends AbstractDirectedGraphNode, E extends AbstractDirectedGraphEdge> extends CandidatePlaceIterator<N>{
	EdgePWSetMatrix<N, E> matrix;
	private int currentK;
	Iterator<Set<E>> currentIterator;
	int maxInputPlusOutput;
	
	
	public EdgesOrderingIteratorOpt(EdgesOrderingCompatibleSelStrategy<N> selectionStrategy, Set<E> edges) {
		super(selectionStrategy);
		this.matrix = new EdgePWSetMatrix<>(edges);
		this.maxInputPlusOutput = selectionStrategy.getInputOutputSum();
		currentK=1;
		currentIterator = this.matrix.getLevel(currentK).iterator();
	}

	public boolean hasNext() {
		if (this.currentIterator.hasNext())
			return true;
		
		if (currentK<maxInputPlusOutput) {
			currentK++;
			matrix.addLevel(currentK);
			currentIterator=matrix.getLevel(currentK).iterator();
			return currentIterator.hasNext();
		}
		
		return false;
	}
	
	public PartialPlaceEvaluation<N> next() {
		if (!this.hasNext())
			throw new RuntimeException("hasNext() must be called before next()!");
		
		Set<E> currentEdgeSet = currentIterator.next();
		return EdgePWSetMatrix.buildPPEFromEdges(currentEdgeSet);
	}
	
	
}
